
from os import system
import java.awt
import java.awt.Button
import javax.swing
import javax.swing.JFrame
import javax.swing.JButton as JButton
import javax.swing as swing
import java.awt as awt
import java.awt.event as event
import com.brackeen.javagamebook.state.MainGameState as MainGameState
import com.brackeen.javagamebook.tilegame.GameManager as GameManager

class MainMenu(event.MouseListener):

    def __init__(self):

        self.imagex = 0
        self.imagey = 0
        self.bDrawImage = False
        freadme = open('help.txt')
        self.readme_text = freadme.read()
        print self.readme_text
        frame = gameManager.screen.getFullScreenWindow()
        self.frame = frame
        #frame = JFrame("KeyTest")
        #frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE)
        #frame.setDefaultCloseOperation(EXIT_ON_CLOSE)
        #frame.setSize(300,150)

        self.contentPane = frame.getContentPane()
        self.cp = self.contentPane
        self.clear()
        self.contentPane.setOpaque(False)

        self.showMain()




    def showMain(self):
        self.clear()
        self.contentPane.setLayout(awt.FlowLayout(awt.FlowLayout.LEFT))
        self.b1 = JButton("Start New Game")
        self.b1.setFocusable(False)
        self.b1.setActionCommand("start")
        self.b1.addMouseListener(self)

        self.b2 = JButton('Continue Previous Game')
        self.b2.setFocusable(False)
        self.b2.setActionCommand("continue")
        self.b2.addMouseListener(self)

        self.b3 = JButton('Settings..')
        self.b3.setFocusable(False)
        self.b3.setActionCommand("settings")
        self.b3.addMouseListener(self)

        #self.b4 = JButton('Hall of Fame')
        #self.b4.setFocusable(False)

        self.bhelp = JButton('Help')
        self.bhelp.setFocusable(False)
        self.bhelp.setActionCommand("help")
        self.bhelp.addMouseListener(self)

        self.bexit = JButton('Exit')
        self.bexit.setFocusable(False)
        self.bexit.setActionCommand("exit")
        self.bexit.addMouseListener(self)

        self.contentPane.add(self.b1)
        self.contentPane.add(self.b2)
        self.contentPane.add(self.b3)
        self.contentPane.add(self.bhelp)
        self.contentPane.add(self.bexit)

        self.b1.addActionListener(inputManager)
        self.b2.addActionListener(inputManager)
        self.b3.addActionListener(inputManager)
        self.bhelp.addActionListener(inputManager)
        self.bexit.addActionListener(inputManager)



    def showHelp(self):
        self.clear()
        cp = self.cp
        c = awt.GridBagConstraints()
        layout = awt.GridBagLayout()
        cp.setLayout(layout)
        c.fill = awt.GridBagConstraints.VERTICAL
        self.ta = swing.JTextArea("Patricia Attack Help")

        self.bback = swing.JButton("Back")
        bback = self.bback
        ta = self.ta

        areaScrollPane = swing.JScrollPane(ta)
        layout.setConstraints(bback,c)
        layout.setConstraints(ta,c)

        ta.setFocusable(False)
        ta.setText(self.readme_text)
        bback.addActionListener(inputManager)
        bback.setFocusable(False)
        bback.setActionCommand("back")
        cp.add(bback)
        cp.add(ta)


    def showSettings(self):
        pass
    def showSaves(self):
        pass

    def reinit(self):
        self.clear()
        self.__init__

    def activate(self):
        menuGameState.activate()
    def deactivate(self):
        menuGameState.deactivate()
    def clear(self):
        self.contentPane.removeAll()
    def showAcceptExit(self):
        self.clear()
        cp = self.cp
        cp.setLayout(awt.FlowLayout(awt.FlowLayout.CENTER))
        label = swing.JLabel("<HTML><FONT COLOR='blue'><B>Do you really want to suicide?</B></FONT></HTML>")
        buttonyes = swing.JButton("Yes, I do.")
        buttonno = swing.JButton("No way!")
        buttonyes.setFocusable(False)
        buttonno.setFocusable(False)
        buttonyes.addActionListener(inputManager)
        buttonno.addActionListener(inputManager)
        buttonyes.setActionCommand("exitbuttonyes")
        buttonno.setActionCommand("exitbuttonno")
        cp.add(label)
        cp.add(buttonyes)
        cp.add(buttonno)
        self.exitbuttonyes = buttonyes
        self.exitbuttonno = buttonno
    def showAcceptNewGame(self):
        self.clear()
        cp = self.cp
        cp.setLayout(awt.FlowLayout(awt.FlowLayout.CENTER))
        label = swing.JLabel("<HTML><FONT COLOR='blue'><B>Do you really want to start a new game?</B> <I>If you proceed the current game state will be lost.</I></FONT></HTML>")
        buttonyes = swing.JButton("Yes")
        buttonno = swing.JButton("No")
        buttonyes.setFocusable(False)
        buttonno.setFocusable(False)
        buttonyes.addActionListener(inputManager)
        buttonno.addActionListener(inputManager)
        buttonyes.setActionCommand("newgamebuttonyes")
        buttonno.setActionCommand("newgamebuttonno")
        cp.add(label)
        cp.add(buttonyes)
        cp.add(buttonno)
        self.newgamebuttonyes = buttonyes
        self.newgamebuttonno = buttonno
    def showSubmitScore(self):#the placeholder for submit score
        pass
    def showHighscores(self):#the placeholder for score showing routine
        pass
    def swingActionPerformed(self):
        print 'actionPerformed(e)'
        e = swingEvent
        command = e.getActionCommand()
        if("start"==command):
            print 'starting..'
            if(resourceManager.getCurrentMap()==1):
                MainGameState.map = resourceManager.loadMap(1)
                self.showMain()
                self.deactivate()
            else:
                self.showAcceptNewGame()
        elif("continue"==command):
            print 'continue'
            self.deactivate()
        elif("back"==command):
            print 'returning to main menu'
            self.showMain()
        elif("help"==command):
            print 'help menu'
            self.showHelp()
        elif("settings"==command):
            print 'settings menu'
        elif("exit"==command):
            print 'exiting..'
            self.showAcceptExit()
            #MainGameState.endGame()
            #self.deactivate()
        elif("exitbuttonyes"==command):
            MainGameState.endGame()
            self.deactivate()
        elif("exitbuttonno"==command):
            self.showMain()
        elif("newgamebuttonyes"==command):
            MainGameState.map = resourceManager.loadMap(1)
            self.showMain()
            self.deactivate()
        elif("newgamebuttonno"==command):
            self.showMain()

    def updateCoordinates(self):
        self.imagex = GameManager.window.getWidth()/2 - menuGameState.imageCurrent.getWidth()/2
        self.imagey = 100
    def draw(self):
        g = graphics
        if(self.bDrawImage):
            g.drawImage(menuGameState.imageCurrent,self.imagex,self.imagey,None)
    def mouseEntered(self,mouseEvent):
         print 'swingMouseEntered()'
         e = mouseEvent
         #print e.getComponent()
         if(menuGameState.compareJavaObj(e.getSource(),self.b1)):
             print 'you are over start button!'
             self.bDrawImage = True
             menuGameState.imageCurrent = menuGameState.image1
             self.updateCoordinates()
         elif(menuGameState.compareJavaObj(e.getSource(),self.b2)):
             print 'you are over continue button!'
             self.bDrawImage = True
             menuGameState.imageCurrent = menuGameState.image2
             self.updateCoordinates()
         elif(menuGameState.compareJavaObj(e.getSource(),self.b3)):
             print 'you are over settings button!'
             self.bDrawImage = True
             menuGameState.imageCurrent = menuGameState.image3
             self.updateCoordinates()
         elif(menuGameState.compareJavaObj(e.getSource(),self.bhelp)):
             print 'you are over help button!'
             self.bDrawImage = True
             menuGameState.imageCurrent = menuGameState.image4
             self.updateCoordinates()
         elif(menuGameState.compareJavaObj(e.getSource(),self.bexit)):
             print 'you are over exit button!'
             self.bDrawImage = True
             menuGameState.imageCurrent = menuGameState.image5
             self.updateCoordinates()
    def mouseExited(self,mouseEvent):
        self.bDrawImage = False
    def mousePressed(self,mouseEvent):
        pass
    def mouseReleased(self,mouseEvent):
        pass
    def mouseClicked(self,mouseEvent):
        pass



